#include "define_all.h"  
#include "string.h"

#define SSP_TBIT 	(8*clkmode)		//36us עcpuƵʱ

#define	I2CREAD		1	//I2C
#define	I2CWRITE	0	//I2Cд

#define	STARTBIT	0	
#define	RESTARTBIT	1
#define	STOPBIT		2
#define	ACKBIT		3



uint08 I2C_Send_Bit( uint08 BIT_def ) 
{
	uint08 i;

	I2C_I2CCTRL_I2CEN_Setable(ENABLE);//ʹI2C·
	
	switch(BIT_def)
	{
		case STARTBIT:
			I2C_SEND_STARTBIT();
			break;
		
		case RESTARTBIT:
			I2C_SEND_RESTARTBIT();
			break;
		
		case STOPBIT:
			I2C_SEND_STOPBIT();
			break;
		
		case ACKBIT:
			I2C_SEND_ACKBIT();
			break;
		
		default:
			break;
	}
	
	for( i=0; i<2*SSP_TBIT; i++ )
	{
		if( SET == I2C_I2CIR_I2CIF_Chk() ) break;
	}

	if( i < 2*SSP_TBIT )
	{
		I2C_I2CIR_I2CIF_Clr(); //clr int flag
		i = I2C_I2CSTA_RW_Chk(); //clr flag through reading SSPSTA.
		
		return 0; //ok
	}
	else
	{
		return 1; //failure.
	}
}


uint08 I2C_Send_Byte( uint08 x_byte ) 
{
	uint16 i;

	I2C_I2CBUF_Write(x_byte);//дͻĴ

	for( i=0; i<18*SSP_TBIT; i++ )
	{
		if( SET == I2C_I2CIR_I2CIF_Chk() ) break; //жϱ־λʱѭ
	}
	
	if( i < 18*SSP_TBIT )
	{
		I2C_I2CIR_I2CIF_Clr(); //clr int flag

		if( SET == I2C_I2CSTA_ACKSTA_Chk() ) //ӻӦ
		{
			return 2; //ʧ
		}
		else
		{
			return 0; //ɹ
		}
	}
	else
	{
		return 1; //failure.
	}
}

uint08 I2C_Receive_Byte( uint08 *x_byte ) 
{
	uint16 i;

	//i2c en, rcen
	I2C_I2CCTRL_RCEN_Setable(ENABLE);

	for( i=0; i<18*SSP_TBIT; i++ )
	{
		if( SET == I2C_I2CIR_I2CIF_Chk() ) break; //жϱ־λ, ѭ
	}

	if( i < 18*SSP_TBIT )
	{
		*x_byte = I2C_I2CBUF_Read();

		I2C_I2CIR_I2CIF_Clr(); //clr int flag

		return 0;
	}
	else
	{
		return 1; //failure.
	}
}

uint08 Sendaddr( uint08 Device, uint16 Addr, uint08 AddrLen, uint08 Opt ) 
{
	uint08 result, Devi_Addr;
	
	Devi_Addr = Device;

	//-------------- reset i2c -------------
	I2C_ResetI2C();//λI2C
	
	//-------------- start bit -------------
	result = I2C_Send_Bit( STARTBIT );//ʼλ
	if( result != 0 ) return 1; //failure.
	
	//-------------- disable read -------------
	I2C_I2CCTRL_RCEN_Setable( DISABLE );

	//-------------- device addr -------------
	result = I2C_Send_Byte( Devi_Addr ); //ַ
	if( result != 0 ) return 2; //failure.

	//--------------- data addr --------------
	if(AddrLen == 2)
	{
		result = I2C_Send_Byte( Addr>>8 ); //ݵַ8λ
		if( result != 0 ) return 3; //failure.
	}
	result = I2C_Send_Byte( Addr>>0 ); //ݵַ8λ
	if( result != 0 ) return 3; //failure.

	if( Opt == I2CREAD ) //
	{
		result = I2C_Send_Bit( RESTARTBIT ); //ʼλ
		if( result != 0 ) return 5; //failure.
		
		result = I2C_Send_Byte( Devi_Addr|1 ); //ַ,ȡ
		if( result != 0 ) return 5; //failure.
	}
		
	return 0; //ok
}

uint08 Wait_for_end( uint08 Device )
{
	uint08 result, Devi_Addr;

	Devi_Addr = Device;
	
	Do_DelayStart(); //Ҫ5msڲд, ѭһʱ: 42Delay()
	{
		I2C_Send_Bit( STARTBIT );	//ʼλ

		result = I2C_Send_Byte( Devi_Addr ); //ַ

		I2C_Send_Bit( STOPBIT ); //ֹͣλ

		if( result == 0 ) return 0; //õַɹ, дڽ
    
	}While_DelayMsEnd(5*clkmode);

	return 1; //õַʧ
}

uint08 I2C_Write_Bottom(uint08 Device, uint16 Addr, uint08 AddrLen, uint08 *Buf, uint08 Len)
{
	uint08 k, n, status;
	
	if(Len > 128) return 0xFF;//һ128ֽ
	
	for( k=0; k<3; k++ )//ÿд3 
	{                                   	
		status = 0;
		if( Sendaddr( Device, Addr, AddrLen, I2CWRITE ) ) 
        {
            status = 1; //дʧ
        }
		else 
		{
			for( n=0; n<Len; n++ )
			{
				//һֽ
				if( I2C_Send_Byte( Buf[n] ) ) 
                {
                    status = 1; 
                    break;
                } //дʧ
			}
		}
		//ֹͣλ
		if( I2C_Send_Bit( STOPBIT ) ) 
            status = 1;
		
		if( status == 0 ) 
        {
            Wait_for_end(Device);
            break;
        } //дȷ
	}
	
	return( status );
}

uint08 I2C_Read_Bottom(uint08 Device, uint16 Addr, uint08 AddrLen, uint08 *Buf, uint08 Len)
{
	uint08 k, n, status;
	
	if(Len > 128) return 0xFF;//һ128ֽ
	
	for( k=0; k<3; k++ )//ÿ3
	{
		status = 0;
		if( Sendaddr( Device, Addr, AddrLen, I2CREAD ) )
            status = 1; //дʧ
		else 
		{
			for( n=0; n<Len; n++ )
			{
				//һֽ
				if( I2C_Receive_Byte( Buf+n ) ) 
                {
                    status = 1; 
                    break;
                } 
        		
				if( n < (Len-1) )
					I2C_SEND_ACK_0();	//ӻĻӦΪ0
				else
					I2C_SEND_ACK_1();	//ӻĻӦΪ1
				
				// ACK
				if( I2C_Send_Bit( ACKBIT) )  //ʧ
				{
					I2C_SEND_ACK_0();
					status = 1; 
					break;
				}	
				I2C_SEND_ACK_0();
			}
		}
		//ֹͣλ
		if( I2C_Send_Bit( STOPBIT ) ) 
             status = 1;	//ʧ
		
		if( status == 0 ) break;//ȷ
	}
	
	return( status );
}

void I2C_Init(void)
{
	RCC_PERCLK_SetableEx(I2CCLK, ENABLE);		//I2Cʱʹ
	
	//I2CIO
	AltFunIO( GPIOA, GPIO_Pin_14, ALTFUN_OPENDRAIN );	//PA14;//SDA
	AltFunIO( GPIOA, GPIO_Pin_15, ALTFUN_OPENDRAIN );	//PA15;//SCL
	
	I2C_I2CBRG_Write(I2C_BaudREG_Calc( 100000, 8000000));//100k@8M
	I2C_I2CIR_I2CIE_Setable(DISABLE);//رI2Cж
	I2C_I2CERR_ERRIE_Setable(DISABLE);//رI2Cж	
	
	NVIC_DisableIRQ(I2C_IRQn);
//	NVIC_SetPriority(I2C_IRQn,2);
//	NVIC_EnableIRQ(I2C_IRQn);	
}

#define DEVICE_FM38025T     0x64	//FM38025Tַ
#define ADDRLEN_FM38025T	1		//FM38025TݵַΪ1ֽ


// FM38025Tλ
void FM38025TReset(void)
{
    IWDT_Clr();             //ϵͳŹ	

    I2C_Send_Bit( STARTBIT );//ʼλ
    
    // TODOʼλIIC豣1s,ܸλFM38025T IIC״̬
    TicksDelayMs(1000, NULL );//ʱ
    
    IWDT_Clr();             //ϵͳŹ	
}

// FM38025T
uint08 FM38025TRead(uint08 Device, uint16 Addr, uint08 AddrLen, uint08 *Buf, uint08 Len)
{
    uint08 Result;

    Result = I2C_Read_Bottom(Device, Addr, AddrLen, Buf, Len);//FM38025T
    if (Result != 0)
    {
        FM38025TReset();
        Result = I2C_Read_Bottom(Device, Addr, AddrLen, Buf, Len);//FM38025T
    }
    
    return Result;
}

// FM38025Tд
uint08 FM38025TWrite(uint08 Device, uint16 Addr, uint08 AddrLen, uint08 *Buf, uint08 Len)
{
    uint08 Result;

    Result = I2C_Write_Bottom(Device, Addr, AddrLen, Buf, Len);//FM38025T
    if (Result != 0)
    {
        FM38025TReset();
        Result = I2C_Write_Bottom(Device, Addr, AddrLen, Buf, Len);//FM38025T
    }
    
    return Result;
}

// FM38025Tȡ¶ֵ
uint08 FM38025TReadTemperature(int16 *temperature)
{
    uint08 Result;
    uint08 Buf[2];

    // ȡ¶ֵ
    Result = FM38025TRead(DEVICE_FM38025T, 0x12, ADDRLEN_FM38025T, Buf, 2);//FM38025T¶
    
    if (Result == 0)
    {
        if (Buf[1])
        {
            // λ1ʾ
            *temperature = -(~Buf[0] + 1);
        }
        else
        {
            // λ0ʾ
            *temperature = Buf[0];
        }
    }
    
    return Result;
}


// FM38025TԺ
uint08 Test_FM380205T(void)
{
    uint08 Device = DEVICE_FM38025T;
	uint16 Addr = 0;
	uint08 AddrLen = ADDRLEN_FM38025T;
	uint08 Buf[7];
    uint08 Buf1[7];
    uint08 Buf2[7];
	uint08 Len = 7;
	uint08 Result = 0;
	uint08 TestData[7] = {0x59, 0x59, 0x23, 0x10, 0x31, 0x08, 0x18}; 
	
    uint08 k = 0;
    
    // ೢ3
    for (k = 0; k < 3; k++)
    {
        IWDT_Clr();             //ϵͳŹ	
        
        memset(Buf, 0, 7);
        Result = FM38025TRead(Device, Addr, AddrLen, Buf, Len);//FM38025T
        if (Result != 0)
        {
            Result = 1;
            continue;
        }
        
        memset(Buf, 0x55, 7);
        memcpy(Buf, TestData, Len);
        Result = FM38025TWrite(Device, Addr, AddrLen, Buf, Len);//дFM38025T
        if (Result != 0)
        {
            Result = 2;
            continue;
        }
        
        IWDT_Clr();             //ϵͳŹ	
        
        Result = 0;
        break;
    }
    
    // ȡΣڽλʱֶȡ
    for (k = 0; k < 3; k++)
    {
        IWDT_Clr();             //ϵͳŹ
    
        memset(Buf1, 0, 7);
        memset(Buf2, 0, 7);
        
        Result = FM38025TRead(Device, Addr, AddrLen, Buf1, Len);//FM38025T
        if (Result != 0)
        {
            Result = 3;
            continue;
        }
        Result = FM38025TRead(Device, Addr, AddrLen, Buf2, Len);//FM38025T
        if (Result != 0)
        {
            Result = 4;
            continue;
        }
        
        // ζȡֵһ£ٴζȡ
        if (memcmp(Buf1, Buf2, Len))
        {
            Result = 5;
            continue;
        }
        
        IWDT_Clr();             //ϵͳŹ
        
        Result = 0;
        break;
    }
    
    return Result;
}

int main (void)
{	
    int16 temperature = 0;

	Init_System();				//ϵͳʼ 
	
	I2C_Init();
	Test_FM380205T();
	FM38025TReadTemperature(&temperature);
    
	for( ; ; )
    {
		IWDT_Clr();             //ϵͳŹ	
		
        LED0_TOG;	            //LED0˸
		TicksDelayMs( 50, NULL );//ʱ
    }	
}


